#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1200one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 1200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1200one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one12004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


# -------------------------------------------------------------------------------------------------
# 1200
# -------------------------------------------------------------------------------------------------                                          
shot2one12004xi = {
                  1:'0x0y1199z',
                  2:'0x36y1199z',
                  3:'0x794y899z',
                  4:'110x1063y544z',
                  5:'11x131y1192z',
                  6:'120x757y922z',
                  7:'120x983y676z',
                  8:'125x892y791z',
                  9:'12x20y1199z',
                  10:'150x1099y457z',
                  11:'157x741y930z',
                  12:'164x1051y554z',
                  13:'170x877y800z',
                  14:'170x969y686z',
                  15:'17x1004y656z',
                  16:'17x118y1194z',
                  17:'17x31y1199z',
                  18:'193x723y937z',
                  19:'1x12y1199z',
                  20:'1x24y1199z',
                  21:'207x1085y468z',
                  22:'20x105y1195z',
                  23:'214x859y809z',
                  24:'218x1035y565z',
                  25:'219x952y696z',
                  26:'21x43y1199z',
                  27:'228x702y945z',
                  28:'23x55y1198z',
                  29:'23x92y1196z',
                  30:'24x67y1197z',
                  31:'24x80y1197z',
                  32:'256x839y818z',
                  33:'261x681y952z',
                  34:'262x1068y479z',
                  35:'266x932y705z',
                  36:'270x1017y576z',
                  37:'292x657y959z',
                  38:'297x816y827z',
                  39:'313x910y715z',
                  40:'316x1048y490z',
                  41:'321x996y586z',
                  42:'322x633y967z',
                  43:'32x916y773z',
                  44:'336x792y835z',
                  45:'350x606y974z',
                  46:'357x886y725z',
                  47:'35x0y1199z',
                  48:'35x1117y434z',
                  49:'369x1025y501z',
                  50:'371x972y596z',
                  51:'373x766y844z',
                  52:'376x579y981z',
                  53:'37x29y1199z',
                  54:'400x551y987z',
                  55:'400x860y734z',
                  56:'409x738y852z',
                  57:'419x946y607z',
                  58:'41x784y907z',
                  59:'420x1000y511z',
                  60:'422x521y994z',
                  61:'441x831y744z',
                  62:'442x491y1001z',
                  63:'442x708y861z',
                  64:'45x39y1198z',
                  65:'460x460y1007z',
                  66:'465x917y617z',
                  67:'470x972y522z',
                  68:'474x677y869z',
                  69:'476x428y1014z',
                  70:'480x800y753z',
                  71:'490x397y1020z',
                  72:'502x364y1027z',
                  73:'503x644y877z',
                  74:'509x886y627z',
                  75:'517x768y762z',
                  76:'518x941y533z',
                  77:'51x49y1197z',
                  78:'530x610y886z',
                  79:'54x1073y533z',
                  80:'552x733y772z',
                  81:'552x853y638z',
                  82:'556x575y894z',
                  83:'563x908y544z',
                  84:'578x539y902z',
                  85:'57x61y1197z',
                  86:'585x698y781z',
                  87:'592x817y648z',
                  88:'599x502y909z',
                  89:'5x143y1191z',
                  90:'607x873y554z',
                  91:'615x660y790z',
                  92:'617x465y917z',
                  93:'61x73y1196z',
                  94:'630x780y658z',
                  95:'633x427y925z',
                  96:'643x622y799z',
                  97:'648x836y565z',
                  98:'65x86y1195z',
                  99:'665x741y668z',
                  100:'669x582y808z',
                  101:'67x112y1192z',
                  102:'67x99y1194z',
                  103:'688x796y576z',
                  104:'692x541y817z',
                  105:'698x701y678z',
                  106:'69x995y666z',
                  107:'6x9y1199z',
                  108:'712x499y825z',
                  109:'724x755y586z',
                  110:'729x658y688z',
                  111:'73x137y1290z',
                  112:'757x615y697z',
                  113:'758x712y597z',
                  114:'783x570y707z',
                  115:'790x667y607z',
                  116:'79x906y782z',
                  117:'819x621y617z',
                  118:'81x772y915z',
                  119:'93x1110y445z'}
                                    

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1200one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1200one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE120ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE120ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE120ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE120ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE120ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE12004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one12004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE120ONE4XI - SUCCEEDED TO PUT SHOT2ONE12004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE12004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time  
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE120ONE4XI *** FAILED TO PUT SHOT2ONE12004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE120ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one12004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one12004xi</nack2put4xi>" 
               
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
      
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE120ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one12004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE120ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE120ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1200one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
